<template>
  <q-no-ssr>
    <q-layout view="hhh lpR fff" class="bg-black">
      <q-header class="transparent" height-hint="98">
        <q-toolbar
          class="toolbar-container block-style q-px-none"
          v-if="pagesData"
        >
          <q-tabs
            v-if="$q.screen.gt.xs"
            v-model="selectedTab"
            active-bg-color="red"
            indicator-color="transparent"
            dense
            active-class="block-style"
            @update:model-value="autoplay ? resetTimer() : ''"
          >
            <q-tab
              v-for="(item, index) in pagesData"
              :key="index"
              :name="item?.id"
              :label="item?.attributes?.tabName"
              no-caps
              content-class="tab-style "
              :ripple="false"
            />
          </q-tabs>
          <q-btn
            v-else
            color="red"
            :label="pagesData[+selectedTab - 1]?.attributes?.tabName"
            class="block-style menu-button"
          >
            <q-menu
              fit
              anchor="bottom left"
              self="top left"
              auto-close
              class="block-style menu-style"
            >
              <q-item
                clickable
                v-for="(item, index) in pagesData"
                :key="index"
                @click="(selectedTab = item?.id), resetTimer()"
              >
                <q-item-section>{{ item?.attributes?.tabName }}</q-item-section>
              </q-item>
            </q-menu>
          </q-btn>

          <q-space />

          <div class="flex items-center">
            <div class="button-with-progress">
              <q-circular-progress
                :value="progress"
                size="40px"
                color="orange"
                :animation-speed="progressFraction"
                :min="0"
                :max="1"
              >
              </q-circular-progress>
              <q-btn
                :icon="!autoplay ? 'play_arrow' : 'pause'"
                color="red"
                flat
                round
                text-color="white"
                @click="autoplay ? stopAutochangeTab() : autochangeTab()"
              />
            </div>
            <q-btn
              :icon="!noiseOn ? 'live_tv' : 'tv_off'"
              color="red"
              flat
              round
              style="height: 40px; width: 40px"
              text-color="white"
              @click="noiseOn = !noiseOn"
            />
            <div class="button-with-progress" v-on:wheel="mouseVolume">
              <q-circular-progress
                :value="$refs.qmp.currentTime()"
                size="40px"
                color="orange"
                :min="0"
                :max="qmpDuration"
              >
              </q-circular-progress>
              <q-btn
                :icon="isPlaying ? 'music_note' : 'music_off'"
                color="red"
                flat
                round
                size="12px"
                text-color="white"
                style="z-index: 10"
                @click="$refs.qmp.togglePlay()"
              />
              <q-knob
                v-model="qmpVolume"
                :thickness="0.2"
                v-if="!$q.platform.is.mobile"
              />
            </div>
          </div>
        </q-toolbar>
      </q-header>
      <template v-for="(item, index) in backgroundImgAll" :key="item"
        ><img
          :my-visible="selectedTab == index + 1"
          :src="item"
          class="fullscreen image-full"
          draggable="false"
      /></template>

      <canvas
        v-show="noiseOn"
        ref="canvas"
        class="fullscreen canvas__container"
      ></canvas>
      <q-page-container
        class="page-container fit flex cursor-pointer"
        style="z-index: 0"
        v-touch-swipe.mouse="handleSwipe"
        v-touch-swipe.touch="handleSwipe"
      >
        <!-- <router-view /> -->
        <div style="margin: auto">
          <q-card
            class="my-card block-style hvr-push"
            flat
            square
            v-if="pageText"
          >
            <q-card-section class="text-style" v-html="pageText">
            </q-card-section>
          </q-card>
        </div>
        <q-resize-observer @resize="onResize" />
      </q-page-container>

      <q-footer class="transparent text-white q-px-none">
        <div class="footer-container">
          <div class="footer-text block-style text-center">
            Автоматизация и спасение мира
          </div>
          <q-no-ssr>
            <div style="display: none">
              <q-media-player
                type="audio"
                :muted="muted"
                :autoplay="false"
                :sources="audio.sources"
                track-language="Russian"
                no-video
                ref="qmp"
                preload="none"
                loop
                no-controls
                :volume="qmpVolume"
                @duration="(seconds) => (qmpDuration = seconds)"
                @play="isPlaying = true"
                @playing="isPlaying = true"
                @paused="isPlaying = false"
              >
              </q-media-player></div
          ></q-no-ssr>
        </div>
      </q-footer> </q-layout
  ></q-no-ssr>
</template>
<script>
import { defineComponent, ref } from 'vue';
import { useQuery, useResult } from '@vue/apollo-composable';
import { pages, other, musics } from 'src/queries/queries';
import { logErrorMessages } from '@vue/apollo-util';
import { useQuasar } from 'quasar';
import { computed } from 'vue';
import { LocalStorage } from 'quasar';
import { createMetaMixin } from 'quasar';

const metaData = {
  // sets document title
  title: 'Главная',
  // optional; sets final title as "Index Page - My Website", useful for multiple level meta
  titleTemplate: (title) => `${title} - ПК "Советские роботы"`,

  // meta tags
  meta: {
    description: { name: 'description', content: 'ПК "Советские роботы"' },
    keywords: { name: 'keywords', content: 'ПК "Советские роботы"' },
    equiv: {
      'http-equiv': 'Content-Type',
      content: 'text/html; charset=UTF-8'
    },
    // note: for Open Graph type metadata you will need to use SSR, to ensure page is rendered by the server
    ogTitle: {
      property: 'og:title',
      // optional; similar to titleTemplate, but allows templating with other meta properties
      template(ogTitle) {
        return `${ogTitle} - ПК "Советские роботы"`;
      }
    }
  },
  // JS tags
  script: {
    ldJson: {
      type: 'application/ld+json',
      innerHTML: `{ "@context": "http://schema.org" }`
    }
  },
  // <html> attributes
  htmlAttr: {
    'xmlns:cc': 'http://creativecommons.org/ns#', // generates <html xmlns:cc="http://creativecommons.org/ns#">,
    empty: undefined // generates <html empty>
  },
  // <noscript> tags
  noscript: {
    default: 'This is content for browsers with no JS (or disabled JS)'
  }
};

export default defineComponent({
  name: 'MainLayout',

  components: {},
  mixins: [createMetaMixin(metaData)],
  setup() {
    const $q = useQuasar();
    const isHorizontal = computed(() => {
      return $q.screen.width > $q.screen.height;
    });

    const { result, loading, onError } = useQuery(pages, null, {
      clientId: 'default'
    });
    const {
      result: resultOther,
      loading: loadingOther,
      onError: onErrorOther
    } = useQuery(other, null, {
      clientId: 'default'
    });
    const {
      result: resultMusics,
      loading: loadingMusics,
      onError: onErrorMusics
    } = useQuery(musics, null, {
      clientId: 'default'
    });
    onErrorMusics((error) => {
      if (process.env.NODE_ENV !== 'production') {
        logErrorMessages(error);
      }
    });
    onErrorOther((error) => {
      if (process.env.NODE_ENV !== 'production') {
        logErrorMessages(error);
      }
    });
    onError((error) => {
      if (process.env.NODE_ENV !== 'production') {
        logErrorMessages(error);
      }
    });

    const pagesData = useResult(result, null, (data) => data.pages.data);
    const otherData = useResult(
      resultOther,
      null,
      (data) => data.other.data.attributes
    );
    const musicsData = useResult(
      resultMusics,
      null,
      (data) => data.musics.data
    );

    return {
      loading,
      loadingOther,
      loadingMusics,
      musicsData,
      pagesData,
      otherData,
      selectedTab: ref('1'),
      noiseOn: ref(true),
      isHorizontal
    };
  },
  data() {
    return {
      timeoutNumber: null,
      timeout: 15000,
      autoplay: true,
      progress: 0,
      progressTimer: null,
      progressFraction: 100,
      acceptCookies: false,
      noiseMoveTimeout: 5,
      noiseMoveCounter: 0,
      muted: false,
      overlay: false,
      isPlaying: false,
      qmpVolume: 40,
      qmpDuration: null
    };
  },

  computed: {
    audio() {
      //"musicsData.0.attributes.audiofile.data.attributes.url"
      if (!Array.isArray(this.musicsData)) {
        const audio = {};
        audio.sources = [
          {
            src: 'mp3/Teknokomo2.mp3',
            type: 'audio/mp3'
          }
        ];

        return audio;
      }

      const audio = {};
      audio.sources = this.musicsData.map((element) => {
        return {
          src: `${process.env.API_URI}${element.attributes.audiofile.data.attributes.url}`,
          type: 'audio/mp3'
        };
      });
      return audio;
    },
    acceptCookiesMessage: function () {
      return this.otherData?.acceptCookies || 'Мы используем файлы cookies.';
    },
    backgroundImgAll: function () {
      if (!this.pagesData) {
        return [];
      }
      return this.pagesData.map((element) => {
        return `${process.env.API_URI}${
          element.attributes?.background[
            this.isHorizontal ? 'horizontal' : 'vertical'
          ].data?.attributes?.url
        }`;
      });
    },
    pageText: function () {
      let text;
      try {
        text = this.pagesData[+this.selectedTab - 1]?.attributes?.text;
      } catch {
        text = null;
      }
      return text;
    }
  },
  watch: {
    qmpVolume: function (val) {
      LocalStorage.set('qmpVolume', val);
    }
  },
  methods: {
    mouseVolume({ deltaY }) {
      if (deltaY < 0) {
        if (this.qmpVolume < 100) {
          this.qmpVolume++;
        } else {
          this.qmpVolume = 100;
        }
      } else {
        if (this.qmpVolume > 0) {
          this.qmpVolume--;
        } else {
          this.qmpVolume = 0;
        }
      }
    },
    handleSwipe({ evt, ...touchSwipeEvent }) {
      if (touchSwipeEvent.distance.x > 5) {
        if (touchSwipeEvent.direction === 'left') {
          if (+this.selectedTab === this.pagesData.length) {
            this.selectedTab = '1';
          } else {
            this.selectedTab = `${+this.selectedTab + 1}`;
          }
        } else if (touchSwipeEvent.direction === 'right') {
          if (this.selectedTab === '1') {
            this.selectedTab = this.pagesData.length;
          } else {
            this.selectedTab = `${+this.selectedTab - 1}`;
          }
        }
        this.resetTimer();
      }
    },
    onResize() {
      if (this.$refs.canvas) {
        this.$refs.canvas.height = window.innerHeight;
        this.$refs.canvas.width = window.innerWidth;
        this.generateNoise();
        requestAnimationFrame(this.moveNoise);
      }
    },
    generateNoise() {
      this.noise = document.createElement('canvas');
      this.noise.height = window.innerHeight * 2;
      this.noise.width = window.innerWidth * 2;
      let noiseContext = this.noise.getContext('2d');
      let noiseData = noiseContext.createImageData(
        this.noise.width,
        this.noise.height
      );
      let buffer32 = new Uint32Array(noiseData.data.buffer);
      let len = buffer32.length - 1;
      while (len--) {
        buffer32[len] = Math.random() < 0.5 ? 0 : -1 >> 0;
      }
      noiseContext.putImageData(noiseData, 0, 0);
    },
    moveNoise() {
      let canvas = this.$refs.canvas;
      if (!canvas) {
        return;
      }
      this.noiseMoveCounter++;
      if (this.noiseMoveCounter >= this.noiseMoveTimeout) {
        this.noiseMoveCounter = 0;
        let context = canvas.getContext('2d');
        let x = Math.random() * canvas.width;
        let y = Math.random() * canvas.height;
        context.clearRect(0, 0, canvas.width, canvas.height);
        context.drawImage(this.noise, -x, -y);
      }
      requestAnimationFrame(this.moveNoise);
    },
    autochangeTab() {
      this.autoplay = true;
      const _this = this;
      if (this.autoplay) {
        this.setProgress();
      }
      _this.timeoutNumber = setTimeout(function tick() {
        if (_this.pagesData) {
          if (_this.pagesData.length === +_this.selectedTab) {
            _this.selectedTab = '1';
          } else {
            _this.selectedTab = `${+_this.selectedTab + 1}`;
          }
          _this.setProgress();
        }
        _this.timeoutNumber = setTimeout(tick, _this.timeout);
      }, _this.timeout);
    },
    stopAutochangeTab() {
      this.autoplay = false;
      clearTimeout(this.timeoutNumber);
      clearTimeout(this.progressTimer);
      this.progress = 0;
    },
    resetTimer() {
      if (this.autoplay) {
        this.stopAutochangeTab();
        this.autochangeTab();
      }
    },
    setProgress() {
      clearTimeout(this.progressTimer);

      this.progress = 0;
      let start = Date.now();
      const _this = this;

      _this.progressTimer = setTimeout(function tick() {
        let timeFraction = parseInt(Date.now() - start) / _this.timeout;
        if (timeFraction >= 1) {
          timeFraction = 0;
          clearTimeout(_this.progressTimer);
        }
        _this.progress = timeFraction;
        if (timeFraction < 1) {
          _this.progressTimer = setTimeout(tick, _this.progressFraction);
        }
      }, _this.progressFraction);
    }
  },
  mounted() {
    if (this.autoplay) this.autochangeTab();
    this.acceptCookies = LocalStorage.getItem('acceptCookies');

    if (!this.acceptCookies) {
      setTimeout(() => {
        this.$q.notify({
          //progress: true,
          message: this.acceptCookiesMessage,
          color: 'red',
          multiLine: true,
          timeout: 0,
          html: true,
          actions: [
            {
              label: 'Согласен',
              color: 'white',
              handler: () => {
                this.acceptCookies = true;
                LocalStorage.set('acceptCookies', true);
              }
            }
          ]
        });
      }, 2000);
    }
    this.qmpVolume = LocalStorage.getItem('qmpVolume') || 40;
  }
});
</script>
<style>
:root {
  --header-height: 50px;
  --footer-height: 50px;
  --top-and-bottom-margin: 20px;
  --page-height: calc(
    100vh - var(--header-height) - var(--footer-height) -
      var(--top-and-bottom-margin)
  );
}

.toolbar-container,
.footer-container {
  max-width: 1200px;
  margin: auto;
  padding-left: 4px;
  padding-right: 4px;
}

.toolbar-container {
  margin-top: var(--top-and-bottom-margin);
}

.footer-container {
  margin-bottom: var(--top-and-bottom-margin);
}

.canvas__container {
  mix-blend-mode: soft-light;
  opacity: 0.15;
  pointer-events: none;
  z-index: 1;
}

.page-container {
  min-height: 100vh;
  width: 100vw;
}

.menu-button {
  height: 42px;
  width: 120px;
}

.block-style {
  clip-path: polygon(
    15px 0,
    100% 0,
    100% calc(100% - 15px),
    calc(100% - 15px) 100%,
    0 100%,
    0 15px
  );
  background-color: rgba(8, 23, 38, 0.6);
  border-radius: 0;
}

.my-card {
  max-width: 750px;
  margin: 24px;
  font-size: 24px;
  padding: 24px;
}

.menu-style {
  font-size: 25px;
}

.footer-text {
  font-size: 20px;
  height: 50px;
  line-height: 46px;
}

.text-style > a {
  color: orange;
  text-decoration: none;
}

.tab-style .q-tab__label {
  font-size: 20px;
  font-weight: 700;
}

.image-full {
  height: 100%;
  width: 100%;
  object-fit: cover;
  z-index: 0;
  transition: opacity 1s ease-in-out;
}

.image-full[my-visible='false'] {
  opacity: 0;
}

.q-tab:hover,
.q-tab:focus,
.q-tab:active {
  clip-path: polygon(
    15px 0,
    100% 0,
    100% calc(100% - 15px),
    calc(100% - 15px) 100%,
    0 100%,
    0 15px
  );
}

.button-with-progress {
  display: grid;
  grid-template-columns: 50px;
  grid-template-rows: 50px;
  align-items: center;
  justify-content: center;
  justify-items: center;
}

.button-with-progress > * {
  grid-area: 1/1;
}

@media (max-width: 1240px) {
  .toolbar-container,
  .footer-container {
    margin-left: 24px;
    margin-right: 24px;
    width: auto;
  }
}

@media (max-width: 600px) {
  .my-card {
    margin: 16px;
    font-size: 20px;
    padding: 16px;
  }

  .toolbar-container,
  .footer-container {
    margin-left: 16px;
    margin-right: 16px;
  }
}

@media (max-width: 400px) {
  .my-card {
    margin: 12px;
    font-size: 18px;
    padding: 12px;
  }

  .toolbar-container,
  .footer-container {
    margin-left: 12px;
    margin-right: 12px;
  }

  .footer-text {
    font-size: 18px;
    height: 50px;
    line-height: 46px;
  }

  .tab-style .q-tab__label {
    font-size: 18px;
  }
}
</style>

<style>
/* Push */
@-webkit-keyframes hvr-push {
  50% {
    -webkit-transform: scale(0.99);
    transform: scale(0.99);
  }
  100% {
    -webkit-transform: scale(1);
    transform: scale(1);
  }
}

@keyframes hvr-push {
  50% {
    -webkit-transform: scale(0.99);
    transform: scale(0.99);
  }
  100% {
    -webkit-transform: scale(1);
    transform: scale(1);
  }
}

.hvr-push {
  vertical-align: middle;
  -webkit-transform: perspective(1px) translateZ(0);
  transform: perspective(1px) translateZ(0);
  box-shadow: 0 0 1px rgba(0, 0, 0, 0);
}

.hvr-push:hover,
.hvr-push:focus,
.hvr-push:active {
  -webkit-animation-name: hvr-push;
  animation-name: hvr-push;
  -webkit-animation-duration: 0.3s;
  animation-duration: 0.3s;
  -webkit-animation-timing-function: linear;
  animation-timing-function: linear;
  -webkit-animation-iteration-count: 1;
  animation-iteration-count: 1;
}
</style>
